/*
 * Correccio:
 *
	1 - Definir atributs adequats per al mecanisme d'exclussio mutua.
	2 - Realitzar els metodes 'entra_zc' i 'surt_zc' del mecanisme
		d'exclussio mutua.
	3 - Inserir adequadament les invocacions a metodes 'entra_zc'
		i 'surt_zc' en el codi del metode 'run'.
 *
 */

public class Puerta1 extends Thread
{
    protected SharedInteger cuenta;
    protected SharedInteger torn_aquest;
    protected SharedInteger torn_altre;
    protected SharedInteger torn;
    protected int valor;
    protected int N_iter = 20;

    public Puerta1(SharedInteger c, SharedInteger t_aquest, SharedInteger t_altre, SharedInteger t, int i)
    {
	cuenta = c;
	torn_aquest = t_aquest;
	torn_altre = t_altre;
	torn = t;
	valor = i;
    }

    public void run()
    {
	for (int i=1; i<=N_iter; i++) {
	    // Detecta nou cotxe
	    	espera_cotxe();
		System.out.println(
			"cotxe detectat (" + this + "): i=" + i
		);
	    entra_zc();
	    // Zona crtica
		int v = cuenta.get();	// Sentencia 1
		v = v + 1;		// Sentencia 2
		cuenta.set(v);		// Sentencia 3
	    surt_zc();
	}
    }

    protected void espera_cotxe()
    {
	try {
	    Thread.sleep((int)(500.0*Math.random()));
	} catch(InterruptedException e) {
	}
    }


    protected void entra_zc()
    {
	// A omplir per l'alumne
	torn_aquest.set(1);
	torn.set(valor);

	while ((torn_altre.get() ==1)&& (torn.get()!=valor)) {};


    }

    protected void surt_zc()
    {
	// A omplir per l'alumne
	torn_aquest.set(0);

    }


    public static void main(String[]arg)
    {
	// Crea comptador compartit
	SharedInteger cuenta = new SharedInteger();
	SharedInteger torn_p1 = new SharedInteger();
	SharedInteger torn_p2 = new SharedInteger();
	SharedInteger torn = new SharedInteger();

	//Crea i inicialitza processos porta
	Puerta1 puerta1 = new Puerta1(cuenta, torn_p1, torn_p2, torn, 1);
	puerta1.start();
	Puerta1 puerta2 = new Puerta1(cuenta, torn_p2, torn_p1, torn, 0);
	puerta2.start();

	// Espera que acabin els processos porta
	try{
		puerta1.join();
		puerta2.join();
	} catch(InterruptedException e) {
	}
	System.out.println("numero final de cotxes = " + cuenta.get());
    }

}
