

public class Buffer
{
    protected CircularQueue q;

    public Buffer(int cp)
    {
    	q = new CircularQueue(cp);
    }

    public synchronized Object get()
    {
        while (q.empty()) {
            try {
                wait();
            } catch (InterruptedException e) { }
        }
        Object result = q.get();
        notifyAll();
        return result;
    }

    public synchronized void put(Object value)
    {
        while (q.full()) {
            try {
                wait();
            } catch (InterruptedException e) { }
        }
        q.put(value);
        notifyAll();
    }
}
