//Clase que gestiona el funcionamiento del sistema en su conjunto.

public class Primos
{
	public static void main(String[] args){
	//Argumentos: Nmero de primos y Nmero de procesos

	int numTrab = Integer.parseInt(args[1]);
	int N = Integer.parseInt(args[0]);
	Gestor g = new Gestor(N);
	Trabajador[] trab;
	trab = new Trabajador[10];
	int i;
	for (i=0;i<numTrab;i++)
	{
		trab[i] = new Trabajador(g, N);
		trab[i].start();
	}



	while (true)
	{}

	}
}

//----------------------------------------------------------

// Cliente trabajador para el sistema de obtencin de primos

class Trabajador extends Thread
{
    	int[] primos;		// Vector de nmeros primos
	int  ultimo_indice;	// Indice del ltimo primo obtenido
	int i;
	int candidato;
	boolean es_primo;
	Gestor g2;


    Trabajador(Gestor g3, int N /* Parte P*/) {
	// int N = g2.N;
	primos = new int[N];
	primos[0] = 3;
	ultimo_indice=0;

	g2 = g3;
    }

    public void run() {
    	while (true) {

	    candidato = g2.siguiente_candidato(); // Obtiene siguiente candidato


    	    if (candidato==0) {
    		break;	// acaba
    	    }
    	    es_primo = true;
    	    i= 0;
    	    while (es_primo && (primos[i]*primos[i] <= candidato)) {
    		if (candidato % primos[i] == 0) {
    		    es_primo = false; // candidato no es primo
    		} else {
		    i = i + 1; // avanza al siguiente indice
		    if (i > ultimo_indice) {

    		    	// Obtiene del gestor el primo con ndice i
			primos[i]=g2.primo(i);
    		    	ultimo_indice = ultimo_indice + 1;

    		    }
    		}
    	    }

    	    	// Notifica al gestor que el candidato es un nuevo primo
    	        g2.nuevo_primo(candidato, es_primo);
    	}


    }

}

//--------------------------------------------------------------

//Clase gestor, productor de nmeros (candidatos a) primos


class Gestor
{
	int[] primos;
	int ultim_candidat;
	int ultim_comprovat;
	int ultim_index;

      /*
        Inicializa la tabla de primos, establece el primer candidato a primo
        y el primer candidato pendiente de verificacin (por parte de un
        trabajador)
      */

	Gestor(int N)
	{
		primos = new int[N];
		primos[0] = 3;
		ultim_index=0;

		ultim_candidat = 3;
		ultim_comprovat = 3;

	}




      /*
	Mtodo que devuelve el siguiente candidato a primo
      */

	public synchronized int siguiente_candidato()
	{
		ultim_candidat = ultim_candidat +2;
		return ultim_candidat;
	}




      /*
	Mtodo que devuelve el primo correspondiente a una posicin
	de la tabla de primos  (en caso de existir)
      */

	public synchronized int primo(int index)
	{

		/*
		  Debe esperar a que la posicin de la tabla contenga el valor
                  correcto.

 	        */

		while(index > ultim_index)
		{
			try{wait();}
			catch(InterruptedException e) {;}
		}
		return primos[index];

	}




      /*
        Mtodo que actualiza la tabla de primos
      */

	public synchronized void nuevo_primo(int primo, boolean es_primo)
	{

           /*
             Debe atender los resultados de los trabajadores en orden
             creciente para poder introducir los nmeros de forma ordenada. Al
             introducir un nuevo primo en la tabla debe: avanzar al siguiente y
             notificar el evento
                  
           */
 		while(primo > ultim_comprovat +1)
		{
			try{wait();}
			catch(InterruptedException e) {;}
		}

		ultim_comprovat = primo;
		if(es_primo)
		{
			ultim_index ++;
			primos[ultim_index]=primo;
		}

		notifyAll();
	}

}
