
package mastermind;

import ... // Classes importades


public class Server {

    //Atributs
    protected Dispatcher dispatcher;

    //Longitud del secret
    protected static int secret_len;

    //Nmero de colors
    protected static int secret_colors;
    protected Secret secret;

    // El Vector jugadors mant el nmero de jugadors
    // en la partida
    protected Vector jugadors;

    // Nmero d'intents totals
    protected int intents;


    public Server(int port, int len, int colors)
    {

	// Construir un Dispatcher .....
	dispatcher= new Dispatcher();

	// Construir el Vector jugadors ....
	jugadors = new Vector();


	// Inicialitzar intents ....
	intents=0;


	// Construir secret ....
	secret_len =len;
	secret_colors=colors;
	secret = new Secret(len, colors);



        try{
		// Construir un ListenSocket (ServerSocket) ....
			// ListenSocket(int port)
		ListenSocket listensocket = new ListenSocket(port);
		// Construir un Acceptor(EventHandler) pel socket (Handle) creat i
		// registrar tots dos al Dispatcher .....

		Acceptor acceptor = new Acceptor(listensocket, this);

		dispatcher.register_handler(listensocket, acceptor);



        } catch (IOException e) {
		System.out.println("No puc escoltar pel port "+port);
		return;
	}

	// Esperar i despatxar events
	while (true) {
		dispatcher.handle_events(-1);
	}
    }

    // Mtode per afegir jugadors a la partida
    //
    public void afegirJugador(Assistent j)
    {
	// Si no hi ha cap jugador ....
	// dirl-li que s el primer ...
	if(jugadors.size()=0)
	{
		j.escriure("Ets el primer!");
	} else if(jugadors.size()>0)   	// si ja hi ha jugadors informar-los a tots del nou jugador ...
	{
		/*
		for (i=0; i<jugadors.size(); i++)
		{
			jugadors[i].escriure("S'ha connectat un nou jugador.");
		}
		*/
		bradcastJugador("S'ha connectat un nou jugador.");
		j.escriure("Jugador nou, ja estas dins del joc. Hi ha " + i + "jugadors");

		// informar al nou jugador del format del secret....
		j.escriure("\nEl format del secret es:\nLongitud: " + secret_len + "\nNum Colors: " + secret_colors);

	} else
	{
		// error

	}


	// afegir el jugador al Vector jugadors .....
	jugadors.addElement(j);

    }


    // Mtode que tracta una jugada
    //
    public void intentJugador(Assistent j, String resposta)
    {
	// Comprobar si resposta es vlida ....
	boolean respostavalida = true;
	if(resposta.length()== secret_len)
	{
		for(i=0;i<resposta.length();i++)
		{	if ((int)resposta[i]>secret_colors)
			{	respostavalida = false;
				break;
			}
		}


		/*
			if(resposta.substring(i,i+1) >= secret_colors)
			{
				respostavalida = false;
			 	break;
			 }
		*/

	}
	else
	{
		respostavalida=false;
	}


	if (respostavalida == false)
		j.escriure("Resposta amb format invalid.");
	else
	{
		j.escriure("Resposta amb format valid.");
		// si no s vlida indicar-ho al jugador i retornar ....

		intents++;
		/*
		for (i=0; i<jugadors.size(); i++)
		{
			jugadors[i].escriure("Jugada nova: "+resposta);
		} */

		broadcastJugadors("Jugada nova: "+resposta);




	// si s vlida
		// incrementar el nombre d'intents i informar a tots els
		// jugadors de la jugada ....

	// Si s'ha endevinat la combinaci:
		// Indicar-ho al jugador que ha guanyat
		// Informar a tots els jugadors
		// Crear un nou secret per recomenar la partida.......
	if(resposta.compareTo(secret.combinacio))
	{	j.escriure("Ho has encertat!!!\n");
		/*for (i=0; i<jugadors.size(); i++)
		{
			jugadors[i].escriure("El jugador "+j.nick + " Ho ha encertat. \nLa combinaci era: " + resposta);
		}*/

		broadcastJugadors("El jugador "+j.nick + " Ho ha encertat. \nLa combinaci era: " + resposta);
		secret = new Secret(len, colors);

	}
    }


    // Mtode que serveix per eliminar un jugador que abandona la partida
    //
    public void eliminaJugador(Assistent j)
    {
        //Informar de l'abandonament a la resta de jugadors ......

/*	for (int i=0; i<jugadors.size(); i++)
	{
		jugadors[i].escriure("S'ha eliminat el jugador "+j.nick());
	}
*/
	broadcastJugadors("S'ha eliminat el jugador "+j.nick())

	j.escriure("\nHas estat eliminat.");

	// Despedir-se del jugador ....


	// treure el jugador del Vector jugadors.....
	jugadors.remove(j);


    }

    // Mtode per informar al conjunt actual de jugadors
    //
    private void broadcastJugadors(String miss)
    {
	// Obtenir un iterador pel Vector jugadors ......

	Enumeration iterador;

	iterador= jugadors.elements();

	// Utilitzar l'iterador per escriure el missatge miss als jugadors ....

	while(iterador.hasMoreElements())
		iterador.nextElement().escriure(miss);

    }



    public static void main(String[] args)
    {
	// Construir el servidor ....
		Server g  = new Server(args[0], args[1], args[2]);


    }

}




// classe que modela el comportament dels EventHandlers que
// accepten peticions de connexi
//
class Acceptor implements EventHandler {

    protected ListenSocket socket;
    protected Server gestor;

    Acceptor(ListenSocket s, Server g)
    {
        gestor = g;
	socket = s;
    }

    // mtode que tracta un event de petici de connexi
    //
    public void handle_event(Handle h)
    {
        try{
        	// acceptar la nova connexi

		Assistent tmp = new Assistent(socket.accept(),gestor);


		// Construir un objecte Assistent que tractar events
		// posteriors en aquest socket ......

        } catch (IOException e) {
		System.out.println("No puc acceptar nova connexi");
	}
    }
}



// classe que modela el comportament dels EventHandlers que
// tracten els events que produeix un jugador
//
class Assistent implements EventHandler {

    protected StreamSocket fluxe;
    protected Server gestor;
    private String nick;

    Assistent(StreamSocket s, Server g)
    {
        gestor = g;
        fluxe = s;

	// registrar l'assistent i el seu handle al Dispatcher ......

	// Demanar el nick al jugador ....
    }


    // Escriure s a l'stream fluxe ....
    public void escriure(String s)
    {
        fluxe.write_line(s);
    }

    // LLegir de l'stream fluxe ....
    public String llegir()
    {
	return fluxe.read_line();
    }



    public String nick()
    {
	// Obtenir el nick del jugador...
	return nick;

    }

    // Mtode que tracta els missatges (events) d'un jugador
    //
    public void handle_event(Handle h)
    {
	// Llegir la resposta del fluxe ....

	// Si resposta vlida (diferent de null)...

		// Si nick s null llavors la resposta s el nick....

	gestor.afegirJugador(this);
			// Crear afegir jugador al gestor...

	if(nick==null)
		nick=llegir();
	else

		// si nick no s null es tracta d'un intent de jugada....

	// si la resposta no s valida ....

		// eliminar al jugador del gestor ....
		//  i desregistrar al jugador del Dispatcher ....

		// per acabar tancar el fluxe .....
    }

}


// Classe que modela el comportament del secret a endevinar
//
class Secret {

    String combinacio;
    int encerts_totals, encerts_parcials;


    // Cosntructor
    // len: longitud del secret
	//
    Secret(int len, int colors)
    {
	// si numero de colors no es correcte llanar una excepci
	// de tipus IllegalArgumentException ....
	if(len<3 || len >10|| colors>10 || colors<2)
	{
		throw new IllegalArgumentException("Error en els parametres");
	}

	// Crear una combinaci de len colors...
	combinacio = '';
	for(int i=0;i<len;i++)
		combinacio = combinacio + (int)(Math.random()*colors)


    }


    // Calcula el nombre d'encerts en una combinaci modificant
    // els atributs encerts_totals i encerts_parcials
    // segons correspongui
    // Retorna cert si el format de s s vlid
    boolean calcula_encerts(String s)
    {
	// ......
	if (s.lenght()!=len)
		return false;

	for(int i=0;i<len;i++)
	{	if ((int)s[i]>colors)
			return false;
	}


	encerts_totals=0;
	encerts_parcials=0;

	for(int i=0;i<len;i++)
	{
		if(s[i]==combinacio[i])
			encerts_totals++;

		for(int j=0;j<len;j++)
		{	if(s[j]==combinacio[i])
				encerts_parcials++;
		}


	}
	return true;

    }

}

