
package io_handle;

import java.util.*;
import java.io.*;
import java.net.*;


public class ReadHandle implements Handle {
    protected BufferedReader entrada;
    protected boolean ready_, closed_;
    protected String line;


    public ReadHandle(BufferedReader br) {
	entrada = br;
	new ReadThread(this).start();
    }


    public synchronized String read_line() {
	while (!ready_) {
	    try { wait(); } catch (InterruptedException e) { }
	}
	String s = line;
	line = null;
	ready_ = false;
	notifyAll();
	return s;
    }


    public boolean ready() {
	return ready_;
    }


    public boolean closed() {
	return closed_;
    }


    public void close() throws IOException {
	closed_ = true;
	ready_ = false;
	entrada.close();
	entrada = null;
	line = null;
    }


    synchronized void put (String l) {
	while (ready_) {
	    try { wait(); } catch (InterruptedException e) { }
	}
	line = l;
	ready_ = true;
	SynchronousDemultiplexer.instance().notify_event(this);
	notify();
    }

}


class ReadThread extends Thread {
    private ReadHandle handle;


    ReadThread(ReadHandle h) {
        handle = h;
    }


    public void run() {
	while (! handle.closed_) {
	    BufferedReader br = handle.entrada;
	    if (br == null) {
		break;
	    }
	    String line = null;
	    try {
		line = br.readLine();
	    } catch (IOException e) {
	    }
	    handle.put(line);
	}
    }

}
