
package io_handle;

import io_handle.*;
import java.io.*;
import java.net.*;


public class StreamSocket {
    protected Socket socket;
    protected ReadHandle entrada;
    protected PrintWriter sortida;


    StreamSocket(Socket s) {
        socket = s;
        try{
            entrada = new ReadHandle(new BufferedReader(
			new InputStreamReader(socket.getInputStream())
	    ));
            sortida = new PrintWriter(socket.getOutputStream(), true);
        } catch (IOException e) {
            System.out.println("Entrada o sortida han fallat");
        }
    }


    public ReadHandle handle() {
        return entrada;
    }


    public void write_line(String s) {
        sortida.println(s);
    }


    public String read_line() {
        return entrada.read_line();
    }


    public boolean read_ready() {
        return entrada.ready();
    }


    public void close() throws IOException {
        entrada.close();
        sortida.close();
        socket.close();
    }

}
