
package io_handle;

import java.util.*;


public class SynchronousDemultiplexer
{

    protected HandleSet read_set2;


    public synchronized int select(HandleSet read_set, HandleSet write_set, long milisecs)
    {
	int result = 0;
	Iterator hsi = read_set.iterator();
	while (hsi.hasNext()) {
		Handle h = (Handle)hsi.next();
		if (h.closed()) {
		    return -1;
		} else if (h.ready()) {
//System.out.println("SynchronousDemultiplexer: Handler "+h+" is ready");
		    result ++;
		    milisecs = 0;
		    read_set2 = null;
		} else {
//System.out.println("SynchronousDemultiplexer: Handler "+h+" is NOT ready");
		    if (milisecs != 0) {
			if (read_set2 == null) { read_set2 = new HandleSet(); }
			read_set2.add(h);
		    }
		    hsi.remove();
		}
	}
	if (milisecs != 0) {
	    try {
		if (milisecs < 0) {
//System.out.println("SynchronousDemultiplexer: Waiting events forever");
		    wait();
		} else {
//System.out.println("SynchronousDemultiplexer: Waiting events for "+milisecs+" miliseconds");
		    wait(milisecs);
		}
	    } catch (InterruptedException e) { }
	    hsi = read_set2.iterator();
	    while (hsi.hasNext()) {
		Handle h = (Handle)hsi.next();
		if (h.ready()) {
//System.out.println("SynchronousDemultiplexer: Handler "+h+" is ready (2nd try)");
		    result ++;
		    read_set.add(h);
		}
	    }
	    read_set2 = null;
	}
	return result;
    }


    synchronized void notify_event(Handle h) {
	if (read_set2 != null && read_set2.contains(h)) {
	    notify();
	}
    }


    protected static SynchronousDemultiplexer instance_mem;

    public static synchronized SynchronousDemultiplexer instance() {
	if (instance_mem == null) {
	    instance_mem = new SynchronousDemultiplexer();
	}
	return instance_mem;
    }
}
