
package reactor;

import io_handle.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class DispatcherImplementation {

    Hashtable demux_table;


    public DispatcherImplementation() {
	demux_table = new Hashtable();
    }


    public void register_handler(Handle h, EventHandler eh) {
	demux_table.put(h,eh);
    }


    public void remove_handler(Handle h) {
	demux_table.remove(h);
    }


    public boolean has_handler(Handle h) {
	return demux_table.contains(h);
    }


    public boolean has_some_handlers() {
	return demux_table.size() > 0;
    }


    public synchronized void handle_events(int milisecs) {
	HandleSet read_set = new HandleSet();
	Enumeration hse = demux_table.keys();
	while (hse.hasMoreElements()) {
	    Handle h = (Handle)hse.nextElement();
	    read_set.add(h);
	}

	int s = SynchronousDemultiplexer.instance().select(read_set,null,milisecs);

	Iterator hsi = read_set.iterator();
	while (hsi.hasNext()) {
	    Handle h = (Handle)hsi.next();
	    ((EventHandler)demux_table.get(h)).handle_event(h);
	}
    }


    static DispatcherImplementation instance_mem;

    public static synchronized DispatcherImplementation instance() {
	if (instance_mem == null) {
	    instance_mem = new DispatcherImplementation();
	}
	return instance_mem;
    }
}


